
#include <stdio.h>
#include <math.h>
#include <malloc.h>

#include "xrlib.h"
#include "error.h"
#include "farbtief.h"
#include "maxwb.h"

#define MOUSEBUTTON RIGHTMOUSE

Display *display;
Visual *visual;
int screen_num;
GC gc;
XImage *xi;
XImage *zi;
XImage *pic[500];
int kennxi =0;
int kennzi =0;
int kennda =0;
char *data;
int *ccfld, *fffld[2];
int randu =0;
int randr =0;
int biweite, bihoehe, weite, hoehe, weitef[2], hoehef[2], kenn;
int xoxu, yoyu;

XColor color;
char *window_name = 
"v ideo       +          -	    e nde ";
/* char *window_name = "xr_Window"; */
char *icon_name = "xr_Icon";
XSizeHints *size_hints;
XWMHints *wm_hints;
XClassHint *class_hints;
XTextProperty name_window, name_icon;
XSetWindowAttributes attributes;
unsigned int line_width;

Colormap colormap;
Colormap errmap;

int rr[16], gg[16], bb[16];
int nzpic;

unsigned  long foreground; 
unsigned  long background; 

char *ErrorString[]={
 "In %s: Unbekannter Fehler",
 "In %s: Kein Speicherplatz mehr",
 "In %s: %s kann nicht geoeffnet werden", 
 "In %s: %s falsches Dateiformat",
 "In %s: Keine Verbindung zum X server",
 "In %s: Kann Farbzellen nicht allokieren",
}; 

unsigned  d = MAXCOL;

int alt = -1;

union {
 XEvent event;
 XKeyEvent keyevent;
 }xr_event;

int mouseleft = 0;
int mouseright = 0;

store pointerpos;

char string[1]={-1};

int offset=0;

xr_Window *wi;

static char *progname;

int xrmax_ (int *xo, int *yo);
void xrinit_( char *argv,int *dxu,int *dyu,int *dxo,int *dyo ); /* o.k. */
void xrendc_ (); /* o.k. */
xr_Window *xr_CreateWindow(int left, int top, int width, int height); /* o.k.*/
void xr_CloseWindow( ); /* o.k. */

void xr_SetPixel( int x, int y); /* o.k. */
void xrsetpixel_( int *x, int *y); /* o.k. */
void xrfarbe_(int *n); /* o.k. */
void xr_SetColor( int *rgb); /* o.k. */
int  xr_TextHeight( ); /* o.k. */
int  xr_TextWidth( ); /* o.k. */
void xr_Printf( const char *format, ...); /* o.k. */
void xrprintf_( int *len, int *xx, int *yy, char *a); /* o.k. */

void xrrand_( void );
void xrrandr_( int *yu, int *yo, int *farbe);
void xrrandu_( int *xu, int *xo, int *farbe);
void xrmarke_ ( int *farbe);
void xrrandcl_( void );
int incurs_ ();

void xrputpixel_( int *x, int *y, int *w);
void xrirgb_( int *r, int *g, int *b);
void xrscanf_( char *a, int *xx, int *yy ,int *size );

int error(int errnum, char *funcname, char *info);
void xrstreck_ (int *xa, int *ya, int *xe, int *ye);

void xr_Move( int x, int y); /* o.k. */
void xrmove_( int *x, int *y); /* o.k. */
void xrline_( int *x, int *y); /* o.k. */
void xrdicke_ (int *n); /* o.k. */
void xr_SetLineWidth (unsigned int line_width); /* o.k. */
void xrkreis_ (int *xa, int *ya, int *xe, int *ye, int *wa, int *we); /*o.k.*/
void xr_Rectangle( int left, int top, int right, int bottom, int fill);/*o.k.*/
void xrrectangle_( int *left, int *top, int *right, int *bottom, int *fill);/**/
void xrellipse_( int *left, int *top, int *right, int *bottom, int *fill);/*ok*/

void xr_GetPixel( int x, int y, int *rgb); /* o.k. */
void xrgetpixel_( int *x, int *y, int *n); /* o.k. */
void xrcls_( ); /* o.k. */

void shwimage_(int *xu, int *yu, int *kame);
void zrshwimage_( int *xu, int *yu, int *width, int *height, int *kame);
void zrcreimage_( int *width, int *height, int *kame);
void zr_CreImage( int width, int height, int kame);
void yrgetimage_( int *width, int *height);
void yrputimage_( int *x, int *y);
void yr_Getimage( int width, int height);
void xrgetimage_( int *width, int *height, int *image);
void xr_Getimage( int width, int height, int *image);
void xrputimage_( int *width, int *height, int *image);
void xr_Putimage( int width, int height, int *image);
void xr_GetPixel( int x, int y, int *rgb);
void xrgetpixel_( int *x, int *y, int *n);
void xrcls_( );
void clrpic_( );
void delpic_( );
void stopic_( );
void shwpic_(int *n);

void xrinkey_ (int *n); /* o.k. */
int xr_GetKey( ); /* o.k. */
int xr_WaitKey( ); /* o.k. */

int xrgetlkr_ (int *x, int *y); /* o.k. */
void xr_MousePos( int *x, int *y); /* o.k. */
int xr_MouseButton( int which); /* o.k. */

unsigned long colorindex(int r, int g, int b); /* o.k. */
void gerade (int xa, int ya, int xe, int ye); /* o.k. */

void delay_(int *n);


void allocfeld_ ( int *width, int *height , int *k);
int wertvonfeld_ ( int *w, int *h , int *k);
void feldvonwert_ ( int *w, int *h, int *k, int *c );
void warten ( );

int xrmax_ (int *xo, int *yo)
{ int x,y;
  x=*xo; y=*yo;
  if(x>MAXWEITE) return(0);
  if(y>MAXHOEHE) return(0);
  return(1);
}

void xrrand_( void )
{
  randu = 6; randr = 6;
}
void xrrandr_( int *yu, int *yo, int *farbe)
{
 int i, k, u, o, v, w;
 w = colorindex( 255, 255, 255);
 u = *yu; o = *yo; v = *farbe;
 if(randu > 0 && randr > 0 && bihoehe > 0 && biweite > 0)
 {
  if(u > 0)
  {
   XSetForeground(display, gc, w);
   for(i=biweite+3;i<biweite+randr;i++)
   for(k=0;k<u;k++)
   xr_SetPixel( i, k);
  }
  XSetForeground(display, gc, v);
  for(i=biweite+3;i<biweite+randr;i++)
  for(k=u;k<=o;k++)
  xr_SetPixel( i, k);
  if(o+1 < bihoehe)
  {
   XSetForeground(display, gc, w);
   for(i=biweite+3;i<biweite+randr;i++)
   for(k=o+1;k<bihoehe;k++)
   xr_SetPixel( i, k);
  }
 } 
}
void xrrandu_( int *xu, int *xo, int *farbe)
{
 int i, k, u, o, v, w;
 w = colorindex( 255, 255, 255);
 u = *xu; o = *xo; v = *farbe;
 if(randu > 0 && randr > 0 && bihoehe > 0 && biweite > 0)
 {
  if(u > 0)
  {
   XSetForeground(display, gc, w);
   for(i=0;i<u;i++)
   for(k=bihoehe+3;k<bihoehe+randu;k++)
   xr_SetPixel( i, k);
  }
  XSetForeground(display, gc, v);
  for(i=u;i<=o;i++)
  for(k=bihoehe+3;k<bihoehe+randu;k++)
  xr_SetPixel( i, k);
  if(o+1 < biweite)
  {
   XSetForeground(display, gc, w);
   for(i=o+1;i<biweite;i++)
   for(k=bihoehe+2;k<bihoehe+randu;k++)
   xr_SetPixel( i, k);
  }
 } 
}
void xrrandcl_( void )
{
 int i, k, w;
 if(randu > 0 && randr > 0 && bihoehe > 0 && biweite > 0)
 {
  w = colorindex( 255, 255, 255);
  XSetForeground(display, gc, w);
  for(i=0;i<biweite+randr;i++)
  for(k=bihoehe;k<bihoehe+randu;k++)
  xr_SetPixel( i, k);
  for(i=biweite;i<biweite+randr;i++)
  for(k=0;k<bihoehe+randu;k++)
  xr_SetPixel( i, k);
 }
}
void xrmarke_ ( int *farbe)
{
 int i,k,w;
 w = *farbe;
 if(randu > 0 && randr > 0 && bihoehe > 0 && biweite > 0)
 {
  XSetForeground(display, gc, w);
  for(i=biweite;i<biweite+randr;i++)
  for(k=bihoehe;k<bihoehe+randu;k++)
  xr_SetPixel( i, k);
 } 
}
void warten (void)
{ 
  long v,w;
  for (w=0; w<5000000; w++) v=w;
} 

void xrprintf_( int *len, int *xx, int *yy, char *a)
{
 int k, x, y;
 int wdth, hght;
 int rgbbg[3]= { 0, 0, 0};
 int rgbfg[3]= { 240, 240, 240};

 x = *xx; y = *yy; k = *len;

/* wdth=98*xr_TextWidth(); */
 wdth= (k+1)*xr_TextWidth();
 hght=xr_TextHeight();
 xr_SetColor(rgbbg);
 xr_Rectangle(x,y-hght,x+wdth,y+hght,FILL);
 xr_SetColor(rgbfg);
 xr_Printf("%s",a);
}

void xrscanf_( char *a, int *xx, int *yy ,int *size )
{
/* int i; */
 int x, y, si; 

 x = *xx; y = *yy;  si = *size; 
	printf("\n xrscanf %ld %ld %ld",x,y,si);
 if(si>100) si=100; 
 strcpy(a,xr_GetString(x,y,si));
 printf("\n xr_GetString %ld %ld %s \n",x,y,a); /* getchar(); */
}


void xrmove_( int *x, int *y)
{
 int xx,yy;

 xx= *x; yy= *y;
 xr_Move( xx, yy);
}

void xrkreis_ (int *xa, int *ya, int *xe, int *ye, int *wa, int *we)
{
 int xxa, yya, wwa, wwe;
 unsigned int xxe, yye;

 xxa= (int) *xa; yya= (int) *ya;
 xxe= (unsigned int) *xe; yye= (unsigned int) *ye;
 wwa= (int) *wa; wwe= (int) *we;
 XDrawArc  (display, wi->drawable, gc, xxa, yya, xxe, yye, wwa, wwe);
 /* wa oder we = 64*winkel */
}

void xrline_( int *x, int *y)
{
 int xx,yy;

 xx = *x; yy = *y; /*
 if(0 <= xx && 0 <= yy && xx < xoxu && yy < yoyu &&
    0 <= wi->start.x && 0 <= wi->start.y && 
    wi->start.x < xoxu && wi->start.y < yoyu) 
  XDrawLine(display, wi->drawable, gc,
            wi->start.x,  wi->start.y,  xx,  yy); 
 else  */
  gerade ( wi->start.x,  wi->start.y,  xx,  yy); 
 wi->start.x = xx;
 wi->start.y = yy;
}

void xrdicke_ (int *n)
{

  line_width = *n;
  xr_SetLineWidth ( line_width);
}

void xrgetpixel_( int *x, int *y, int *n)
{
 int i,rgb[3];
 int xx,yy;

 xx = *x; yy = *y;
 xr_GetPixel( xx, yy, rgb);
 for (i=0; i<16; i++)
 {
   if( rgb[0] == rr[i] && rgb[1] == gg[i] && rgb[2] == bb[i])
   {
     *n = i;  goto marke;
   }
 }
 *n = 0;
 marke:;
}

void xrputpixel_( int *x, int *y, int *w)
{
 int xx, yy, ww;
 xx = *x; yy = *y; ww = *w;
 XPutPixel (xi, xx, yy, ww);
}
void yrgetpixel_( int *x, int *y, int *w)
{
 int xx, yy, ww;
 xx = *x; yy = *y;
 ww = (int) XGetPixel (xi, xx, yy );
}

void xrsetpixel_( int *x, int *y)
{
 int xx,yy;
/* if(xoxu<=0 || yoyu<=0)
  { printf("\n setpix weite hoehe %ld %ld\n",xoxu,yoyu); exit(0); }; */
 xx = *x; yy = *y;
  xr_SetPixel( xx, yy);
/* else
  { printf("\n setpix xx yy xoxu yoyu %ld %ld %ld %ld\n",xx,yy,xoxu,yoyu);
    exit (0);  }; */
}

void xrinit_( char *argv,int *dxu,int *dyu,int *dxo,int *dyo )
{
 int x, y, n, xu, yu, xo, yo;
 xu= *dxu; yu= *dyu; xo= *dxo; yo= *dyo;
 progname = argv;
 wi = xr_CreateWindow(xu, yu, xo, yo);
 nzpic=0; xoxu=xo; yoyu=yo;
}

void xrendc_ ()
{
  xr_CloseWindow( );
}

void xrinkey_ (int *n)
{

  *n = xr_WaitKey();
}

int xrgetlkr_ (int *x, int *y)
{
  int xx,yy,zz,zzz;
  int n;

  xx = *x; yy = *y; zzz = 0;
  while(zzz <= 0)
  {
     zz=xr_MouseButton(MOUSEBUTTON);
     if( zz > 0 )
     {
       while ( xr_MouseButton(MOUSEBUTTON) );
     }
     else
     { zz=xr_GetKey (); }
     zzz=zz;
  }
  n=(int)zzz;
  xr_MousePos( &xx, &yy);
  *x = xx; *y = yy;
  return(n);
}
void xrmausp_ (int *x, int *y)
{
 int xx,yy,zz;
 xx = *x; yy = *y; zz = 0;
 while ( zz <= 0)
 {
   zz = xr_MouseButton(MOUSEBUTTON);
   if(zz > 0)
   {
    xr_MousePos( &xx, &yy);
    *x = xx; *y = yy;
   }
 }
}

void xrfarbe_(int *n)
{
 int rgb[3],k;

 XFlush(display); /* warten();*/
 k=(int)*n;
 if(k != alt)
 {
  alt=k;
  rgb[0]=rr[k]; rgb[1]=gg[k]; rgb[2]=bb[k];
  xr_SetColor( rgb);
 }
 XFlush(display); /* warten(); */
}

void xrirgb_( int *r, int *g, int *b)
{
 int rr, gg, bb;
 rr= *r; gg= *g; bb= *b;
 XSetForeground(display, gc, colorindex(rr, gg, bb));
}

unsigned long colorindex(int r, int g, int b)
{
 unsigned long w;
#if ( FARBTIEFE == 16 )
 return((((r+3L)*4L)/33L)*2048UL+(((g+2L)*16L)/65L)*32L+((b+4L)*4L)/33L);
#else
  w = r; w = w << 8 ; w = w + g ; w = w << 8 ; w = w + b ;
  return(w);
#endif
/*  return(r*65536UL+g*256L+b);  */
}

void xrcls_( )
{
 int rgb[3];

 rgb[0]=0; rgb[1]=0; rgb[2]=0;
 xr_SetColor( rgb);
 XFillRectangle(display,wi->drawable,gc,0,0,
                wi->width, wi->height);
 rgb[0]=240; rgb[1]=240; rgb[2]=240;
 xr_SetColor( rgb);
}

void xrrectangle_( int *left, int *top, int *right, int *bottom, int *fill)
{
 int le,to,ri,bo,fi;

 le=*left; to=*top; ri=*right; bo=*bottom; fi=*fill;
 xr_Rectangle( le, to, ri, bo, fi);
}

void xrellipse_( int *left, int *top, int *right, int *bottom, int *fill)
{
 int le,to,ri,bo,fi,hilf;

 le=*left; to=*top; ri=*right; bo=*bottom; fi=*fill; /* Xflash(); */
 if(le>ri)
  {
   hilf=le; le=ri; ri=hilf;
  } 
 if(to>bo)
  {
   hilf=to; to=bo; bo=hilf;
  } 
 if(fi == NOTFILL)
  XDrawArc(display,wi->drawable,gc,le,to,
           ri-le,bo-to,0,64*360);
 if(fi == FILL)
  XFillArc(display,wi->drawable,gc,le,to,
           ri-le,bo-to,0,64*360);

}

void mainloop(void)
{
 if(XPending(display))
  {
   XNextEvent (display,(XEvent *) &(xr_event.event));
   switch(xr_event.event.type)
    {
     case ButtonPress:
          if(xr_event.event.xbutton.button == 1)
           mouseleft = 1;
          if(xr_event.event.xbutton.button == 3)
           mouseright = 1; 
          break;
     case ButtonRelease:
          if(xr_event.event.xbutton.button == 1)
           mouseleft = 0;
          if(xr_event.event.xbutton.button == 3)
           mouseright = 0; 
          break;
     case KeyPress:
          XLookupString(&(xr_event.keyevent),string,1,NULL,NULL);
          break;     
     default:
          break;
    }
  } 
}


xr_Window *xr_CreateWindow(int left, int top, int width, int height) 
{
 unsigned long r,g,b;
 char *progname = "xr_Window";
 unsigned long valuemask,foreground_pixel;

 wi = (xr_Window *) malloc(sizeof *wi);
 if(wi == NULL)
  {
   error(NOMEMORY,"CreateWindow",NULL);
   return NULL;
  } 

 wi->width = width + randr;
 wi->height = height + randu;
 wi->left = left;
 wi->top = top;

 if (!(size_hints = XAllocSizeHints())) 
  {
   fprintf(stderr, "%s: Fehler beim Allokieren von Speicherplatz\n",
           progname);
   exit(0);        
  }

 if(!(wm_hints = XAllocWMHints()))
  {
   fprintf(stderr, "%s: Fehler beim Allokieren von Speicherplatz\n",
           progname);
   exit(0);
  }

 if(!(class_hints = XAllocClassHint()))
  {
   fprintf(stderr, "%s: Fehler beim Allokieren von Speicherplatz\n",
           progname);
   exit(0);
  } 

 
 if((display = XOpenDisplay(NULL)) == NULL)
  {
   error(CANTOPENDISPLAY,"CreateWindow",NULL);
   return(NULL);
  }
   
 screen_num = DefaultScreen (display);
 XFlush(display); warten();

 
 if(XDoesBackingStore(XScreenOfDisplay(display,screen_num)))
  {
   valuemask = CWBackingStore | CWBackPixel;
   attributes.backing_store = Always;
   attributes.background_pixel = XWhitePixel(display,screen_num);
  }
 else
  {
   valuemask = CWBackPixel;
   attributes.background_pixel = XWhitePixel(display,screen_num);
  }  
  
 wi->window = XCreateWindow (display,
               RootWindow(display,screen_num),
               left, top, width, height, 0, 
               DefaultDepth(display,screen_num),
               InputOutput,
               XDefaultVisual(display,screen_num),
               valuemask, &attributes);
	       XFlush(display); warten();

 size_hints->flags = PPosition | PSize | PMinSize;
 size_hints->min_width = wi->width;
 size_hints->min_height = wi->height;

 if (XStringListToTextProperty(&window_name, 1, &name_window) == 0)
  {
   fprintf(stderr,
    "%s: Fehler beim allokieren der Struktur fuer den Windownamen\n",
           progname);
   exit(-1);        
  }        
 if (XStringListToTextProperty(&icon_name, 1, &name_icon) == 0)
  {
   fprintf(stderr,
     "%s: Fehler beim allokieren der Struktur fuer den Iconnamen\n",
           progname);
   exit(-1);        
  }        

 wm_hints->initial_state = NormalState;
 wm_hints->input = True;
 wm_hints->flags = StateHint | InputHint;

 class_hints->res_name = progname;
 class_hints->res_class = "Basicwindow";

 XSetWMProperties(display,wi->window, &name_window, &name_icon,
             NULL, 0, size_hints, wm_hints, class_hints);
	     XFlush(display); warten();

 XMapWindow(display, wi->window);
 XFlush(display); warten();

 XSelectInput(display, wi->window, StructureNotifyMask |
   ButtonPressMask | ExposureMask | 
   ButtonReleaseMask | KeyPressMask);
   XFlush(display); warten();

 wi->pixmap = XCreatePixmap(display, 
               RootWindow(display,screen_num),
               width, height,
               DefaultDepth(display,
               screen_num));
	       XFlush(display); warten();
                
 gc = XCreateGC (display, RootWindow(display,
                    screen_num), 0, NULL);
		    XFlush(display); warten();

 XSetGraphicsExposures(display,gc,False);
 XFlush(display); warten();

 rr[0]=0; rr[1]=0; rr[2]=0; rr[3]=0; rr[4]=129; rr[5]=129;
 rr[6]=129; rr[7]=129; rr[8]=86; rr[9]=86; rr[10]=86; rr[11]=86;
 rr[12]=215; rr[13]=215; rr[14]=215; rr[15]=215;
 gg[0]=0; gg[1]=0; gg[2]=129; gg[3]=129; gg[4]=0; gg[5]=0;
 gg[6]=86; gg[7]=129; gg[8]=86; gg[9]=86; gg[10]=215; gg[11]=215;
 gg[12]=86; gg[13]=86; gg[14]=215; gg[15]=215;
 bb[0]=0; bb[1]=129; bb[2]=0; bb[3]=129; bb[4]=0; bb[5]=129;
 bb[6]=0; bb[7]=129; bb[8]=86; bb[9]=215; bb[10]=86; bb[11]=215;
 bb[12]=86; bb[13]=215; bb[14]=86; bb[15]=215;
 errmap=wi->colormap=DefaultColormap(display, screen_num);
 XFlush(display); warten();

 wi->drawable = wi->window;

 return (wi);
} 

void gerade (int xa, int ya, int xe, int ye)
{
  int x,y,z,xx,yy,zu,zo;
  float d;
  zo=(int) line_width/2+1; zu=-((int) line_width-1)/2; 
  xx=xe-xa; if(xx<0) xx=-xx;
  yy=ye-ya; if(yy<0) yy=-yy;
  if(yy>xx)
  {
   d=(xe-xa); d=d/(ye-ya);
   if(ya<ye)
   {
    for(y=ya; y<=ye;y++)
    {
     x=xa+d*(y-ya);
     for(z=x+zu; z<x+zo; z++) xr_SetPixel(z,y);
    }
   }
   else
   {
    for(y=ya; y>=ye;y--)
    { 
     x=xa+d*(y-ya);
     for(z=x+zu; z<x+zo; z++) xr_SetPixel(z,y);
    }
   }
  }
  if(yy<xx)
  {
   d=(ye-ya); d=d/(xe-xa);
   if(xa<xe)
   {
    for(x=xa; x<=xe;x++)
    {
     y=ya+d*(x-xa);
     for(z=y+zu; z<y+zo; z++) xr_SetPixel(x,z);
    }
   }
   else
   {
    for(x=xa; x>=xe;x--)
    { 
     y=ya+d*(x-xa);
     for(z=y+zu; z<y+zo; z++) xr_SetPixel(x,z);
    }
   }
  }
  if(yy == xx)
  {
   y=ya; if(yy == 0) yy=1;
   if(xa<xe)
   {
    for(x=xa; x<=xe;x++)
    {
     for(z=x+zu; z<x+zo; z++) xr_SetPixel(z,y);
      y+=(ye-ya)/yy;
    }
   }
   else
   {
    for(x=xa; x>=xe;x--)
    { 
     for(z=x+zu; z<x+zo; z++) xr_SetPixel(z,y);
      y+=(ye-ya)/yy;
    }
   }
  }
}


void xr_SetPixel( int x, int y)
{
 if(0 <= x && 0 <= y && x < xoxu && y < yoyu) 
  XDrawPoint(display, wi->drawable, gc, x,y); 
}

void xrstreck_ (int *sxa, int *sya, int *sxe, int *sye)
{
 int xa,ya,xe,ye;

 xa= *sxa; ya= *sya; xe= *sxe; ye= *sye;
 if(0 <= xa && 0 <= ya && xa < xoxu && ya < yoyu &&
    0 <= xe && 0 <= ye && xe < xoxu && ye < yoyu)
  XDrawLine (display, wi->drawable, gc, xa, ya, xe, ye); 
 else
  gerade ( xa, ya,  xe,  ye); 
 wi->start.x = xe;
 wi->start.y = ye;
 
}

void xr_SetColor( int *rgb)
{
 unsigned long foreground_pixel;
 foreground_pixel=colorindex(rgb[0],rgb[1],rgb[2]);
 XSetForeground(display, gc, foreground_pixel);
}                     

void xr_CloseWindow( )
{
 XFreePixmap(display,wi->pixmap);
 XFreeGC (display, gc);
 XDestroyWindow (display, wi->window);
 XCloseDisplay (display);
 free(wi);
 printf("\n InputFocus free! \n"); 
}

void xr_DrawMode( int mode)
{
 if (mode==NORMAL)
  XSetFunction(display, gc, GXcopy);
 if (mode==XOR) 
  XSetFunction(display, gc, GXxor);
 if (mode==AND) 
  XSetFunction(display, gc, GXand);
 if (mode==OR) 
  XSetFunction(display, gc, GXor);
}

void xr_Printf( const char *format, ...)
{
 va_list vl;
 int i=0;
 char strng[200], *s = &strng[0];
 va_start(vl,format);
 vsprintf(strng,format,vl);
 va_end(vl);
 do{
    while(*(s + i) != '\r' && *(s + i) != '\n' 
          && *(s + i) != '\0') i++;
    XDrawString(display, wi->drawable, gc,
                wi->start.x, wi->start.y, s, i);
    offset+=i;            
    wi->start.x+=(i*xr_TextWidth( ));            
    if(*(s+i) == '\n' || *(s+i) == '\r')
     {
      wi->start.y+=xr_TextHeight( );
      wi->start.x-=(offset*xr_TextWidth( ));
      offset=0;
     }                  
    if(*(s+i)=='\0')
      break;
    s=s+i+1;
   }while(*s);
}

int xr_TextHeight( )
{
 XFontStruct *font_struct;
 GContext idgc;

 idgc=XGContextFromGC(gc);
 font_struct=XQueryFont(display,idgc);
 return((int)(font_struct->max_bounds.ascent +
        font_struct->max_bounds.descent));
}

int xr_TextWidth( )
{
 XFontStruct *font_struct;
 GContext idgc;

 idgc=XGContextFromGC(gc);
 font_struct=XQueryFont(display,idgc);
 return((int)(font_struct->max_bounds.width));
}

void xr_SetLineWidth (unsigned int line_width)
{
  int line_style = LineSolid;
  int cap_style  = CapRound;
  int join_style = JoinRound;
  if(d > 0 && d < 32)
  {
  XSetLineAttributes
  (display, gc, line_width, line_style, cap_style, join_style);
  }
  else
  { exit (0); }
}

int xr_GetKey( )
{
 char t;

 mainloop();
 t = string[0];
 string[0] = -1;
 return((int)t);
}

int xr_WaitKey( )
{
 int key;
 
 while((key=xr_GetKey( )) == -1);
 return(key);
}

int incurs_ ()
{
 int key;
 key=xr_GetKey()+1;
}

int error(int errnum, char *funcname, char *info)
{
 Window errwin, root, child;
 char *window_name = "Error";
 char *icon_name = "Error";
 XSizeHints *size_hints;
 XWMHints *wm_hints;
 XClassHint *class_hints;
 XTextProperty name_window, name_icon;
 char *progname = "Error";
 char hilf[100];
 int rootretx, rootrety, x, y;
 int left, top, width, height;
 unsigned int mask;
 XFontStruct *font_struct;
 GContext idgc;

 idgc=XGContextFromGC(gc);
 font_struct=XQueryFont(display,idgc);
 
 sprintf(hilf,ErrorString[errnum],funcname,info);
 height=100;
 width = strlen(hilf)*(font_struct->max_bounds.width)+20;
 left = (XDisplayWidth(display,screen_num)-width)/2;
 top = (XDisplayHeight(display,screen_num)-height)/2;

 if (!(size_hints = XAllocSizeHints())) 
  {
   fprintf(stderr, "%s: Fehler beim Allokieren von Speicherplatz\n",
           progname);
   exit(0); 
  }

 if(!(wm_hints = XAllocWMHints()))
  {
   fprintf(stderr, "%s: Fehler beim Allokieren von Speicherplatz\n",
           progname);
   exit(0); 
  }

 if(!(class_hints = XAllocClassHint()))
  {
   fprintf(stderr, "%s: Fehler beim Allokieren von Speicherplatz\n",
           progname);
   exit(0); 
  } 

 errwin = XCreateWindow (display,
               RootWindow(display,screen_num),
               left, top, width, height, 0, 
               DefaultDepth(display,screen_num),
               InputOutput,
               XDefaultVisual(display,screen_num),
               0, NULL);

 size_hints->flags = PPosition | PSize | PMinSize;
 size_hints->min_width = width;
 size_hints->min_height = height;

 if (XStringListToTextProperty(&window_name, 1, &name_window) == 0)
  {
   fprintf(stderr,
      "%s: Fehler beim allokieren der Struktur fuer den Windownamen\n",
           progname);
   exit(-1);        
  }        

 if (XStringListToTextProperty(&icon_name, 1, &name_icon) == 0)
  {
   fprintf(stderr,
      "%s: Fehler beim allokieren der Struktur fuer den Iconnamen\n",
           progname);
   exit(-1);        
  }        

 wm_hints->initial_state = NormalState;
 wm_hints->input = True;
 wm_hints->flags = StateHint | InputHint;

 class_hints->res_name = progname;
 class_hints->res_class = "Basicwindow";

 XSetWMProperties(display,errwin, &name_window, &name_icon,
             NULL, 0, size_hints, wm_hints, class_hints);

 XMapWindow(display, errwin);
    
 XSetWindowColormap(display,errwin,errmap);   
 
 XSetWindowBackground(display,errwin, XWhitePixel(display,
                      screen_num));
 do{
    XDrawString(display, errwin, gc, 10, 40, hilf, strlen(hilf));                      
    XQueryPointer(display, errwin,&root,&child,
               &rootretx,&rootrety,&x,&y,&mask);
   }while((x > width || x < 0 || y > height || y < 0) || mask != 256);
  
 XDestroyWindow (display, errwin);
 return errnum;
}

void xr_Move( int x, int y)
{
 offset=0;
 wi->start.x = x;
 wi->start.y = y; 
}

void xr_Rectangle( int left, int top,
                  int right, int bottom, int fill)
{
 int hilf;
 if(left>right)
  {
   hilf=left;
   left=right;
   right=hilf;
  } 
 if(top>bottom)
  {
   hilf=top;
   top=bottom;
   bottom=hilf;
  } 
 if(fill == NOTFILL)
  XDrawRectangle(display,
                 wi->drawable,
                 gc,
                 left,top,
                 right-left,bottom-top);
 if(fill == FILL)
  XFillRectangle(display,
                 wi->drawable,
                 gc,
                 left,top,
                 right-left,bottom-top);
}

void xr_MousePos( int *x, int *y)
{
 Window root, child;
 int rootretx, rootrety;
 unsigned int mask;
 
 XQueryPointer(display, wi->window,&root,&child,
               &rootretx,&rootrety,x,y,&mask);
}

int xr_MouseButton(int which)
{
 mainloop();

 switch(which)
  {
   case LEFTMOUSE:
        if(mouseleft == 1)
         return 1;
        break;
   case RIGHTMOUSE:
        if(mouseright == 1)
         return 1;
        break;    
  }
 return 0;
}


void xr_GetColor( int *rgb)
{
 XColor xc;

 xc.pixel = foreground;
 XQueryColor(display,wi->colormap, 
             &xc);
 rgb[0] = xc.red/256;
 rgb[1] = xc.green/256;
 rgb[2] = xc.blue/256;             
}

void xr_GetPixel( int x, int y, int *rgb)
{
 XColor xc;
 
 xi = XGetImage(display, wi->drawable, 0, 0,
                x+1, y+1,
                AllPlanes, ZPixmap);

 xc.pixel = XGetPixel(xi, x, y);

 XQueryColor(display,wi->colormap, 
             &xc);
 rgb[0] = xc.red/256;
 rgb[1] = xc.green/256;
 rgb[2] = xc.blue/256;             
 XFree(xi);
}

char hilf[100];

char *xr_GetString( int x, int y, int size)
{
 int j = 0;
 char help;
 int i, newx;
 int height, width;
 int rgbfg[3] = { 240, 240, 240 };
 int rgbbg[3] = { 0, 0, 0 };
 
 width=size*xr_TextWidth( );
 height=xr_TextHeight( )*2;
 hilf[0]=0;
 xr_SetColor(rgbbg);
 xr_Rectangle(x,y,x+width,y+height,FILL);

 xr_SetColor(rgbfg);
 xr_Move(x+xr_TextWidth( ), y+xr_TextHeight());
 xr_Printf("> ");
 while((help = xr_WaitKey( ))!='\r' && j<size)
  {
   switch(help)
    {
     case 8:
          j--;
          xr_SetColor(rgbbg);
          hilf[j]=0;
          newx=x+(j+3)*xr_TextWidth( );
          xr_Rectangle(newx,y,newx+xr_TextWidth( ),y+height,FILL);
          xr_SetColor(rgbfg);
          wi->start.x-=xr_TextWidth();
          break;
     default:
          xr_Printf("%c",help);
          hilf[j++]=help;
    }
  }
 hilf[j]='\0';
 return(hilf);
}

void allocfeld_ ( int *width, int *height, int *k )
{
  kenn = *k;
  if(kenn == 2) { weite = *width; hoehe = *height; }
/* printf("\n allocfeld %ld %ld %ld",weite,hoehe,kenn); */
  if(kenn < 2)
  {
   weitef[kenn] = *width; hoehef[kenn] = *height;
   biweite = *width; bihoehe = *height;
  }
  if(kenn == 2)
  {
printf("\n malloc %ld x %ld x 4",weite,hoehe);
    if(!(ccfld = (int *) malloc(weite*hoehe*sizeof(int))))
    {
     printf("\n Fehler bei Feld ccfld ( %d , %d )",weite,hoehe);
     exit (0);
    }
  }
  else
  {
printf("\n malloc %ld x %ld x 4",weitef[kenn],hoehef[kenn]);
    if(!(fffld[kenn] = (int *) malloc(weitef[kenn]*hoehef[kenn]*sizeof(int))))
    {
     printf("\n Fehler bei Feld fffld (%d  %d , %d )",kenn,weitef[kenn],hoehef[kenn]);
     exit (0);
    }
  }
}
int wertvonfeld_ ( int *w, int *h, int *k )
{
 int i, j, l;
 i = *w; j = *h; l = *k;
 if(l == 2) return ( (int) *(ccfld+i*hoehe+j));
 if(l < 2) return ( (int) *(fffld[l]+i*hoehef[l]+j));
}
void feldvonwert_ ( int *w, int *h, int *k, int *c )
{
 int i, j, l;
 int f;
 i = *w; j = *h; l = *k; f = *c;
 if(l == 2) *(ccfld+i*hoehe+j) = f;
 if(l < 2) *(fffld[l]+i*hoehef[l]+j) = f;
}
void shwimage_(int *xu, int *yu, int *kame)
{
 int i, j, x, y, w, h, k;
 if(kennxi == 0) { printf(" \n erst image definieren"); getchar (); exit (0); }
 x = *xu; y = *yu; w = xi->width; h = xi->height; k = *kame;
 /* printf("\n shwimage %ld %ld %ld %ld k= %ld",x,y,w,h,k); */
 if(kennda > 0 && kennda != w*h)
 { printf(" \n free(data) "); getchar ();  kennda = 0; free (data); }
 if(kennda == 0)
 {
  /* printf("\n malloc data %ld x %ld x 4",w,h); */
   if(!(data = (char *) malloc(w*h*sizeof(int))))
   { printf(" \n Fehler Allocate data"); getchar(); exit (0); }
   kennda = w*h;
 }
 /* printf("\n for %ld %ld %ld %ld",y,y+h,x,x+w); */
 for(j=y; j<y+h*k; j=j+k)
 for(i=x; i<x+w*k; i=i+k)
 {
  zuweisen_( &(*(data+4*w*(j-y)/k+4*(i-x)/k)) , &(*(ccfld+i*hoehe+j)) );
/*  zuweisen_( &(*(data+2*w*(j-y)/k+2*(i-x)/k)) , &(*(ccfld+i*hoehe+j)) ); */
 }
 xi->data = data;
 /* printf("\n vor XPutImage %ld %ld",w-1,h-1); */
 XPutImage(display, wi->drawable, gc, xi, 0, 0, 0, 0, w-1, h-1);
 /* printf("\n nach XPutImage %ld %ld",w-1,h-1); */
}
void zrshwimage_( int *xu, int *yu, int *width, int *height, int *kame)
{
 int x, y, w, h, k;
 x = *xu; y = *yu; w = *width; h = *height; k = *kame;
 x = x/k; y = y/k;
 XPutImage(display, wi->drawable, gc, zi, x, y, 0, 0, w, h);
}
void zrcreimage_( int *width, int *height, int *kame)
{
  int w, h, k;
  w = *width; h = *height; k = *kame;
  w = w/k; h = h/k;
  zr_CreImage ( w, h, k);
}
void zr_CreImage( int width, int height, int kame)
{
 int i, j;

 if(kennxi == 0) { printf(" \n erst image definieren"); getchar (); exit (0); }
 if(kennda > 0 && kennda != width*height)
 { kennda = 0; free (data); }
 if(kennda == 0)
 {
   if(!(data = (char *) malloc(width*height*sizeof(int))))
   { printf(" \n Fehler Allocate data"); getchar(); exit (0); }
   kennda = width*height;
 }
 zi = XCreateImage(display, visual, xi->depth, 
        xi->format, xi->xoffset, data, width, height, xi->bitmap_pad,
        2*width);
  kennzi = 1;
  for(i = 0; i < width; i++)
  for(j = 0; j < height; j++)
  {
  zuweisen_( &(*(data+2*width*j+2*i)) , &(*(ccfld+kame*(i*hoehe+j))) );
  }
}
void yrgetimage_( int *width, int *height)
{
  int w, h;
  w = *width; h = *height;
  w = 2*(w/2);
  yr_Getimage ( w, h);
/*  XFlush(display);  */
}
void yr_Getimage( int width, int height)
{
  xi = XGetImage(display, wi->drawable, 0, 0,
                width, height,
                AllPlanes, ZPixmap);
  XFlush(display); kennxi = 1;
}
void xrgetimage_( int *width, int *height, int *image)
{
  int w,h;
  w= *width; h= *height;
  /* printf("\n xrgetimage %ld %ld",w,h); */
  xr_Getimage ( w, h, image);
}
void xr_Getimage( int width, int height, int *image)
{
 int i, j;
 /* printf("\n xr_Getimage 0 %ld %ld",width,height); */
 xi = XGetImage(display, wi->drawable, 0, 0,
                width, height,
                AllPlanes, ZPixmap);
 /* printf("\n xr_Getimage 1 %ld %ld",width,height); */
 for (i=0; i<width;i++)
 for (j=0; j<height;j++)
 {
 *(image+i+j*width) = XGetPixel(xi,i,j);
 }
 /* printf("\n xr_Getimage 2 %ld %ld \n",width,height); */
 /* kennxi = 1; XFlush(display);
  printf("\n xr_Getimage 3 %ld %ld",width,height); */
}
void xrputimage_( int *width, int *height, int *image)
{
  int w,h;
  w= *width; h= *height;
/*   printf("\n xrputimage %ld %ld",w,h); */
  xr_Putimage ( w, h, image);
/*   printf("\n xrputimage %ld %ld",w,h); */
}
void xr_Putimage( int width, int height, int *image)
{
 int i, j;
 XColor xc;

 for (i=0; i<width ;i++)          /* /8 striechen */
 for (j=0; j<height;j++)
 {
 XPutPixel(xi,i,j,*(image+i+j*width));
 }
 XPutImage(display, wi->drawable, gc, xi, 0, 0, 0, 0, width, height);
}
void yrputimage_( int *x, int *y)
{
 int width, height;
 
 if ( kennxi == 0) exit (0);
 width = *x; height = *y;
 XPutImage(display, wi->drawable, gc, xi, 0, 0, 0, 0, width, height);
 XFlush(display);
}
void shwpic_ (int *n)
{
 int k;
 k=*n-1; if(k>=nzpic) exit (0);
 XPutImage(display, wi->drawable, gc, pic[k], 0, 0, 0, 0, xi->width, xi->height);
 XFlush(display);
}
void delpic_ ( )
{
 nzpic--; XDestroyImage(pic[nzpic]);
}
void clrpic_ ( )
{
 while(nzpic>0)
 { nzpic--; XDestroyImage(pic[nzpic]); }
}
void stopic_ ( )
{
 pic[nzpic] = XSubImage(xi, 0, 0, xi->width, xi->height);
 nzpic++;if(nzpic>=500) exit(0);
}
void delay_ (int *n)
{
 int k;
 k=*n;
 usleep (k);
/* float w;
 w=*n*.000001;
 sleep (w); */
}
