       implicit none
       logical lingl
       integer n,k,i,ii,err
       real*8 a,w,wert,yvonx,maxf,durchschnitt,fffff
       include 'commointeger4real8.h'
*************************************************
*        common/commoninteger4daten/kz,iz
*        common/commonreal8datenfeld/y,cy,x,xu,xx,xo
*       integer kz,iz
*       real*8 y(  250),cy(  250),x(  250, 2),xu( 2),xx( 2),xo( 2)
*       real*8 p,deltay
*************************************************
       ALLOCATABLE a(:,:)
       open (unit=1,file='ykvonxi.dat',status='OLD')
       read (1,*) !'Potenz der Interpolation'
       read (1,*) p
       read (1,*) !'y (x1,...) Anzahl der Argumente ='
       read (1,*) iz 
       read (1,*) !'Anzahl der Messpunkte yk (x1k,...)'
       read (1,*) kz
       read (1,*) !'Messpunkte'
       do k=1,kz
        read (1,*) y(k),(x(k,i),i=1,iz)
       end do
       read (1,*) !'Bereich xiu < xio'
       do i=1,iz
        read (1,*) xu(i),xo(i)
       end do
       if(iz.gt.1) then
       read (1,*) !'deltay'
       read (1,*) deltay
       end if
       close (unit=1)
       ALLOCATE(a(kz,kz+1),STAT=err)
       if(err.ne.0) stop 'ALLOCATE a'
*      Stetigkeit von y(x1,...
       do n=1,kz
        do k=1,kz
         if(k.ne.n) then
                 ii=0
                 do i=1,iz
                  if(x(n,i).eq.x(k,i)) ii=ii+1
                 end do
                 if(ii.eq.iz) then
                         write(*,*) 'y bei ',n,k,' unstetig'
                         stop 'Ende Interpolation'
                 end if
         end if
        end do
       end do
*      Definition von cy(1,...
       do n=1,kz
        a(n,kz+1)=y(n)
        do k=1,kz
         wert=0.d0
         do i=1,iz
          wert=wert+((x(n,i)-x(k,i))**2)
         end do
         wert=dsqrt(wert)
         a(n,k)=dexp(-p*wert)
        end do
       end do
       if(.not.lingl(a,kz,kz+1)) stop 'lingl in interpolation'
       do n=1,kz
       end do
       do n=1,kz
        cy(n)=a(n,kz+1)
       end do
*      Interpolationsfehler an den Stützpunkte
       maxf=0.d0
       durchschnitt=0.d0
       open (unit=2,file='interpolfehler',status='UNKNOWN')
       do k=1,kz
        do i=1,iz
         xx(i)=x(k,i)
        end do
        wert=yvonx()
        write(2,'(i10,3f20.9)') k,y(k),wert,dabs(y(k)-wert)
        write(*,'(i10,3f20.9)') k,y(k),wert,dabs(y(k)-wert)
        durchschnitt=durchschnitt+dabs(y(k)-wert)
        if(dabs(y(k)-wert).gt.maxf) maxf=dabs(y(k)-wert)
       end do
       durchschnitt=durchschnitt/dfloat(kz)
       write(2,*) 'maxfehler=',maxf,' durchschfehler=',durchschnitt
       write(*,*) 'maxfehler=',maxf,' durchschfehler=',durchschnitt
       close (unit=2)
*      initialisiere yvonx
       open (unit=3,file='yvonx',status='UNKNOWN',form='UNFORMATTED')
       write(3) p,iz,kz
       write(3) (cy(k),k=1,kz)
       do k=1,kz
        write(3) y(k),(x(k,i),i=1,iz)
       end do
       write(3) (xu(i),xo(i),i=1,iz)
       if(iz.gt.0) write(3) deltay 
       close (unit=3)
       open (unit=1,file='bereich',status='UNKNOWN')
       write(1,*) 'iz,kz'
       write(1,*) iz,kz
       write(1,*) 'Bereich xiu < xio'
       do i=1,iz
        write(1,*) xu(i),xo(i)
       end do
       if(iz.gt.1) then
       write(1,*) 'deltay'
       write(1,*) deltay
       end if
       close (unit=1)
       end
